﻿(function () {

    "use strict";

    angular.module("EnrApp")
           .controller("MainController", ["$scope", "$rootScope", "$compile", "$timeout", "$window", "$filter", "jsonDataFetcher", "secondsCountdown", "enrModeManager", "primaryService", "$location",
    function ($scope, $rootScope, $compile, $timeout, $window, $filter, jsonDataFetcher, secondsCountdown, enrModeManager, primaryService, $location) {

        $scope.badgeClassD = "party-badge header-badge";
        $scope.badgeClassR = "party-badge header-badge";
        $scope.isShow = true;
        $scope.isTopBanner = false;
        $scope.modelhidden = true;
        $scope.currentYear = new Date().getFullYear();

        $scope.isSplash = false;

        $scope.onPrimaryPartyChanged = function (partyCode) {
            primaryService.setSelectedParty(partyCode);
        };

        $scope.$on("SELECT_REFERENDUM", function (event, index) {
            $scope.isSplash = false;
        })

        $scope.$on("SELECTED_PARTY_CHANGED", function (event, partyCode, isSplash) {

            $scope.badgeClassD = "party-badge header-badge";
            $scope.badgeClassR = "party-badge header-badge";

            if (isSplash)
                $scope.isSplash = false;

            if (partyCode === "D") {
                $scope.badgeClassD += " selected";
            }
            else if (partyCode === "R") {
                $scope.badgeClassR += " selected";
            }

        });


        $scope.$on("COUNTY_MOUSEOVER_POSITION", function (event, modelhidden, modelTop, modelLeft) {
            $scope.modelhidden = modelhidden;
            $scope.modelTop = modelTop;
            $scope.modelLeft = modelLeft;
        });


        var isEnr = true;

        $scope.bindParams = function (parameters) {
            var isBannerVal = parameters[1].replace("/1.1", "");
            if (parameters[0] == "Type") {
                jsonDataFetcher.registerElectionType(parameters[1]);
            }

            else if (parameters[0] == "isTopBanner") {
                if (isBannerVal == 'Y') {
                    isEnr = false;
                }
            }
            else if (parameters[0] == "isShow") {
                if (isBannerVal == 'N') {
                    isEnr = false;
                }
            }
        }

        var params = $window.location.search;
        if (params) {
           
            if (params.indexOf("?") > -1) {
                if (params.indexOf("&") > -1) {
                    var mutiParams = params.substr(1, params.length).split("&");
                    for (var i = 0; i < mutiParams.length; i++) {
                        var parameters = mutiParams[i].split('=');
                        $scope.bindParams(parameters);
                    }
                }
                else {
                    var mutiParams = params.substr(1, params.length).split("=");
                    $scope.bindParams(mutiParams);
                }
            }
        }



        $scope.modelMouseEnter = function (event) {
            primaryService.setIsMouseArrivedOnModel(true);
        }

        $scope.modelMouseLeave = function (event) {
            primaryService.setIsMouseArrivedOnModel(false);
            $scope.modelhidden = true;
        }

        $scope.$on(enrModeManager.modeChangeEventName, function (event, newMode) {
            // State Constituional Amendment
            if (newMode === enrModeManager.modeEnum.referendums) {
                jsonDataFetcher.fetchSingleJson("statewideElectionsR", true, false, function (jsonResults) {
                    var referendumsData = jsonResults;

                    var jurisdictionJsonFiles = [];
                    var areVersioned = [];
                    var areClientData = [];

                    if (referendumsData != undefined) {
                        if (referendumsData.Regions != undefined && referendumsData.Regions.Region != undefined) {
                            if (referendumsData.Regions.Region.length == undefined)
                                referendumsData.Regions.Region = [referendumsData.Regions.Region];

                            angular.forEach(referendumsData.Regions.Region, function (regionData) {
                                jurisdictionJsonFiles.push("JurR_" + regionData.FIPS);
                                areVersioned.push(true);
                                areClientData.push(false);
                            });

                            jsonDataFetcher.fetchMultipleJson(jurisdictionJsonFiles, areVersioned, areClientData, function (jsonResult) {
                                var positiveResults = 0;
                                var negativeResults = 0;
                                var stateReferendumObject = null;
                                var isStateConstReferendum = false;
                                angular.forEach(jsonResult, function (jurisdictionList) {
                                    if (jurisdictionList.length == undefined)
                                        jurisdictionList = [jurisdictionList];

                                    angular.forEach(jurisdictionList, function (jurisdiction) {
                                        if (jurisdiction.Region != undefined &&
                                            jurisdiction.Region.Reporting_Regions != undefined &&
                                            jurisdiction.Region.Reporting_Regions.Regions != undefined &&
                                            jurisdiction.Region.Reporting_Regions.Regions.Referendums != undefined &&
                                            jurisdiction.Region.Reporting_Regions.Regions.Referendums.Referendum != undefined) {
                                            var referendumArray = jurisdiction.Region.Reporting_Regions.Regions.Referendums.Referendum;
                                            if (referendumArray.length == undefined)
                                                referendumArray = [referendumArray];

                                            angular.forEach(referendumArray, function (referendumObject) {
                                                if (referendumObject.REFERENDUM_TYPE_NAME == "Ratification Of State Constitutional Amendment") {
                                                    isStateConstReferendum = true;
                                                    stateReferendumObject = referendumObject;
                                                    positiveResults += parseInt(referendumObject.POSITIVE_RESULTS);
                                                    negativeResults += parseInt(referendumObject.NEGATIVE_RESULTS);
                                                }
                                            });


                                        }
                                    });
                                });

                                if (isStateConstReferendum) {
                                    stateReferendumObject.POSITIVE_RESULTS = positiveResults;
                                    stateReferendumObject.NEGATIVE_RESULTS = negativeResults;
                                    primaryService.setStateConReferendum(stateReferendumObject);
                                }

                            });

                        }
                    }
                });
            }
        });



        // Start by pulling settings data (which will also give us version information)
        jsonDataFetcher.fetchSingleJson("settings", false, false, function (settingsJson) {
            jsonDataFetcher.registerVersion(settingsJson.VersionType);
            var isCertified = settingsJson.Certified === "T" ? true : false;
            primaryService.setIsCertified(isCertified);

            if (settingsJson.ElectionType === "P" && isEnr)
                $scope.isSplash = true;

            // Now that we know what our version is, pull the rest of the data we need on startup.
            jsonDataFetcher.fetchMultipleJson(["statewideElectionsC", "statewideTickerC", "additionalSettings"], [true, true, false], [false, false, true], function (jsonResults) {

                var officeListJson = jsonResults[0];
                var tickerJson = jsonResults[1];
                var additionalSettings = jsonResults[2];
                var officesData = jsonResults[0].List;

                var officeJsonFiles = [];
                var areVersioned = [];
                var areClientData = [];


                angular.forEach(officesData, function (office) {
                    var val = office;
                    if (office.Items != undefined) {
                        angular.forEach(office.Items.Item, function (officeItem) {
                            //$scope.currentOffices.push(officeItem);
                            officeJsonFiles.push("OffCatC_" + officeItem.OFFICECATEGORYID);
                            areVersioned.push(true);
                            areClientData.push(false);
                        });
                    }
                });

                primaryService.setOfficersJsonData(officeJsonFiles);

                jsonDataFetcher.fetchMultipleJson(officeJsonFiles, areVersioned, areClientData, function (jsonResult) {
                    primaryService.setOfficesList(jsonResult);
                });

                jsonDataFetcher.fetchSingleJson("mapDataIndianaDistricts", false, true, function (jsonResult) {
                    primaryService.setMapDistrictData(jsonResult);
                });

                $scope.ElectionDate = new Date(settingsJson.CurrentElection);
                $scope.VersionTimestamp = settingsJson.VersionCode;

                $scope.DefaultMap = settingsJson.DefaultMapName;

                $scope.SpecialElectionColor = additionalSettings.AdditionalColors.SPECIAL_ELECTION_COLOR;

                settingsJson.PolParties.AdditionalColors = additionalSettings.AdditionalColors;

                $scope.PartyColor = {
                    Republican: null,
                    Democrat: null
                };

                var republicanResults = $filter('filter')(settingsJson.PolParties.PolParty, {
                    PARTY_NAME: "Republican"
                });
                if (republicanResults && republicanResults.length > 0)
                    $scope.PartyColor.Republican = republicanResults[0].DISPLAY_COLOR
                var democratResults = $filter('filter')(settingsJson.PolParties.PolParty, {
                    PARTY_NAME: "Democrat"
                });
                if (democratResults && democratResults.length > 0)
                    $scope.PartyColor.Democrat = democratResults[0].DISPLAY_COLOR

                $scope.MapColorsData = settingsJson.PolParties;
                $scope.MapColorsData.PartyColor = $scope.PartyColor;
                $scope.MapGeoData = undefined;

                $scope.ReportingMeterValue = officeListJson.JurisdictionsReporting.TOTAL_ALLPRECINCTSREPORTING / officeListJson.JurisdictionsReporting.TOTAL_ALLPRECINCTS;
                $scope.PercentReporting = $filter("percentage")($scope.ReportingMeterValue, 1);
                $scope.TotalPrecincts = officeListJson.JurisdictionsReporting.TOTAL_ALLPRECINCTS;

                var initialSecondsTillRefresh = settingsJson.IntervalInMinutes * 60;
                secondsCountdown.start(initialSecondsTillRefresh, function () {
                    localStorage.setItem("isRefresh", "Y");
                    localStorage.setItem("partyCode", primaryService.getSelectedParty());
                    $window.location.reload();
                });
                $scope.SecondsTilRefresh = secondsCountdown.secondsRemaining;
                $scope.RefreshMeterValue = function () {
                    return 1 - ($scope.SecondsTilRefresh() / initialSecondsTillRefresh);
                };

                $scope.OfficeListData = officeListJson;
                $scope.showOfficeList = true;
                $scope.$on(enrModeManager.modeChangeEventName, function (event, newMode) {
                    $scope.showOfficeList = newMode === enrModeManager.modeEnum.offices;
                });
                $scope.IsPrimary = settingsJson.ElectionType === "P";
                primaryService.setElectionType(settingsJson.ElectionType);
                if (tickerJson.ElectionSummaries != undefined)
                    $scope.TickerData = tickerJson.ElectionSummaries.Race;

                if (localStorage.getItem("isRefresh") == "Y") {
                    primaryService.setSelectedParty(localStorage.getItem("partyCode"));
                    localStorage.setItem("isRefresh", "N");
                }

                if ($scope.IsPrimary) {
                    // We default to Democrats because that's alphabetical order.
                    primaryService.setIsPrimary(true, "D");
                }
                primaryService.setPartyColors($scope.PartyColor);

                $scope.stopInterval = function () {
                    secondsCountdown.stopInterval();
                }
                $scope.electionType = primaryService.getElectionType();

                $scope.bindBannerParams = function (parameters) {

                    var isBannerVal = parameters[1].replace("/1.1", "");

                    if (parameters[0] == "isTopBanner") {
                        if (isBannerVal == 'N') {
                            $scope.stopInterval();
                            $scope.isShow = false;
                        }
                        else if (isBannerVal == 'Y') {
                            $scope.stopInterval();
                            $scope.isTopBanner = true;
                        }
                    }
                    else if (parameters[0] == "isShow") {
                        if (isBannerVal == 'N') {
                            $scope.stopInterval();
                            $scope.isShow = false;
                        }
                    }
                    else if (parameters[0] == "year") {
                        if (isBannerVal == '2016') {
                            if ($scope.electionType == 'G')
                                $scope.electionResultsDocument = "Content/documents/Primary Election 2018.doc";
                            else
                                $scope.electionResultsDocument = "Content/documents/Primary Election 2018.doc";
                        }
                    }
                }

                var paramsBanner = $window.location.search;
                if (paramsBanner) {

                    if (paramsBanner.indexOf("?") > -1) {
                        if (paramsBanner.indexOf("&") > -1) {
                            var mutiParams = paramsBanner.substr(1, paramsBanner.length).split("&");
                            for (var i = 0; i < mutiParams.length; i++) {
                                var parameters = mutiParams[i].split('=');
                                $scope.bindBannerParams(parameters);
                            }
                        }
                        else {
                            var mutiParams = paramsBanner.substr(1, paramsBanner.length).split("=");
                            $scope.bindBannerParams(mutiParams);
                        }
                    }
                }

                if ($scope.isShow) {
                    if ($scope.electionType == 'G') {
                        $scope.spanElectionType = 'general';
                        $scope.electionResultsDocument = "Content/documents/Primary Election 2018.doc";
                    }
                    else {
                        $scope.spanElectionType = 'primary';
                        $scope.electionResultsDocument = "Content/documents/Primary Election 2018.doc";
                    }
                }
            });
        });
    }]);
}());
